<?php

namespace Farfetch\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSimpleBoutiqueBarcode ArrayType
 * @subpackage Arrays
 */
class ArrayOfSimpleBoutiqueBarcode extends AbstractStructArrayBase
{
    /**
     * The SimpleBoutiqueBarcode
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Farfetch\StructType\SimpleBoutiqueBarcode[]
     */
    public $SimpleBoutiqueBarcode;
    /**
     * Constructor method for ArrayOfSimpleBoutiqueBarcode
     * @uses ArrayOfSimpleBoutiqueBarcode::setSimpleBoutiqueBarcode()
     * @param \Farfetch\StructType\SimpleBoutiqueBarcode[] $simpleBoutiqueBarcode
     */
    public function __construct(array $simpleBoutiqueBarcode = array())
    {
        $this
            ->setSimpleBoutiqueBarcode($simpleBoutiqueBarcode);
    }
    /**
     * Get SimpleBoutiqueBarcode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Farfetch\StructType\SimpleBoutiqueBarcode[]|null
     */
    public function getSimpleBoutiqueBarcode()
    {
        return isset($this->SimpleBoutiqueBarcode) ? $this->SimpleBoutiqueBarcode : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSimpleBoutiqueBarcode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSimpleBoutiqueBarcode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSimpleBoutiqueBarcodeForArrayConstraintsFromSetSimpleBoutiqueBarcode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSimpleBoutiqueBarcodeSimpleBoutiqueBarcodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfSimpleBoutiqueBarcodeSimpleBoutiqueBarcodeItem instanceof \Farfetch\StructType\SimpleBoutiqueBarcode) {
                $invalidValues[] = is_object($arrayOfSimpleBoutiqueBarcodeSimpleBoutiqueBarcodeItem) ? get_class($arrayOfSimpleBoutiqueBarcodeSimpleBoutiqueBarcodeItem) : sprintf('%s(%s)', gettype($arrayOfSimpleBoutiqueBarcodeSimpleBoutiqueBarcodeItem), var_export($arrayOfSimpleBoutiqueBarcodeSimpleBoutiqueBarcodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SimpleBoutiqueBarcode property can only contain items of type \Farfetch\StructType\SimpleBoutiqueBarcode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SimpleBoutiqueBarcode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Farfetch\StructType\SimpleBoutiqueBarcode[] $simpleBoutiqueBarcode
     * @return \Farfetch\ArrayType\ArrayOfSimpleBoutiqueBarcode
     */
    public function setSimpleBoutiqueBarcode(array $simpleBoutiqueBarcode = array())
    {
        // validation for constraint: array
        if ('' !== ($simpleBoutiqueBarcodeArrayErrorMessage = self::validateSimpleBoutiqueBarcodeForArrayConstraintsFromSetSimpleBoutiqueBarcode($simpleBoutiqueBarcode))) {
            throw new \InvalidArgumentException($simpleBoutiqueBarcodeArrayErrorMessage, __LINE__);
        }
        if (is_null($simpleBoutiqueBarcode) || (is_array($simpleBoutiqueBarcode) && empty($simpleBoutiqueBarcode))) {
            unset($this->SimpleBoutiqueBarcode);
        } else {
            $this->SimpleBoutiqueBarcode = $simpleBoutiqueBarcode;
        }
        return $this;
    }
    /**
     * Add item to SimpleBoutiqueBarcode value
     * @throws \InvalidArgumentException
     * @param \Farfetch\StructType\SimpleBoutiqueBarcode $item
     * @return \Farfetch\ArrayType\ArrayOfSimpleBoutiqueBarcode
     */
    public function addToSimpleBoutiqueBarcode(\Farfetch\StructType\SimpleBoutiqueBarcode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Farfetch\StructType\SimpleBoutiqueBarcode) {
            throw new \InvalidArgumentException(sprintf('The SimpleBoutiqueBarcode property can only contain items of type \Farfetch\StructType\SimpleBoutiqueBarcode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SimpleBoutiqueBarcode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Farfetch\StructType\SimpleBoutiqueBarcode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Farfetch\StructType\SimpleBoutiqueBarcode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Farfetch\StructType\SimpleBoutiqueBarcode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Farfetch\StructType\SimpleBoutiqueBarcode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Farfetch\StructType\SimpleBoutiqueBarcode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SimpleBoutiqueBarcode
     */
    public function getAttributeName()
    {
        return 'SimpleBoutiqueBarcode';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Farfetch\ArrayType\ArrayOfSimpleBoutiqueBarcode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
