<?php

namespace Farfetch\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransportationProperty ArrayType
 * @subpackage Arrays
 */
class ArrayOfTransportationProperty extends AbstractStructArrayBase
{
    /**
     * The TransportationProperty
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Farfetch\StructType\TransportationProperty[]
     */
    public $TransportationProperty;
    /**
     * Constructor method for ArrayOfTransportationProperty
     * @uses ArrayOfTransportationProperty::setTransportationProperty()
     * @param \Farfetch\StructType\TransportationProperty[] $transportationProperty
     */
    public function __construct(array $transportationProperty = array())
    {
        $this
            ->setTransportationProperty($transportationProperty);
    }
    /**
     * Get TransportationProperty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Farfetch\StructType\TransportationProperty[]|null
     */
    public function getTransportationProperty()
    {
        return isset($this->TransportationProperty) ? $this->TransportationProperty : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransportationProperty method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransportationProperty method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransportationPropertyForArrayConstraintsFromSetTransportationProperty(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransportationPropertyTransportationPropertyItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransportationPropertyTransportationPropertyItem instanceof \Farfetch\StructType\TransportationProperty) {
                $invalidValues[] = is_object($arrayOfTransportationPropertyTransportationPropertyItem) ? get_class($arrayOfTransportationPropertyTransportationPropertyItem) : sprintf('%s(%s)', gettype($arrayOfTransportationPropertyTransportationPropertyItem), var_export($arrayOfTransportationPropertyTransportationPropertyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransportationProperty property can only contain items of type \Farfetch\StructType\TransportationProperty, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransportationProperty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Farfetch\StructType\TransportationProperty[] $transportationProperty
     * @return \Farfetch\ArrayType\ArrayOfTransportationProperty
     */
    public function setTransportationProperty(array $transportationProperty = array())
    {
        // validation for constraint: array
        if ('' !== ($transportationPropertyArrayErrorMessage = self::validateTransportationPropertyForArrayConstraintsFromSetTransportationProperty($transportationProperty))) {
            throw new \InvalidArgumentException($transportationPropertyArrayErrorMessage, __LINE__);
        }
        if (is_null($transportationProperty) || (is_array($transportationProperty) && empty($transportationProperty))) {
            unset($this->TransportationProperty);
        } else {
            $this->TransportationProperty = $transportationProperty;
        }
        return $this;
    }
    /**
     * Add item to TransportationProperty value
     * @throws \InvalidArgumentException
     * @param \Farfetch\StructType\TransportationProperty $item
     * @return \Farfetch\ArrayType\ArrayOfTransportationProperty
     */
    public function addToTransportationProperty(\Farfetch\StructType\TransportationProperty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Farfetch\StructType\TransportationProperty) {
            throw new \InvalidArgumentException(sprintf('The TransportationProperty property can only contain items of type \Farfetch\StructType\TransportationProperty, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransportationProperty[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Farfetch\StructType\TransportationProperty|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Farfetch\StructType\TransportationProperty|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Farfetch\StructType\TransportationProperty|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Farfetch\StructType\TransportationProperty|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Farfetch\StructType\TransportationProperty|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransportationProperty
     */
    public function getAttributeName()
    {
        return 'TransportationProperty';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Farfetch\ArrayType\ArrayOfTransportationProperty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
