<?php

namespace Farfetch\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetMainViewResponse StructType
 * @subpackage Structs
 */
class GetMainViewResponse extends AbstractStructBase
{
    /**
     * The GetMainViewResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $GetMainViewResult;
    /**
     * The ItemID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ItemID;
    /**
     * Constructor method for GetMainViewResponse
     * @uses GetMainViewResponse::setGetMainViewResult()
     * @uses GetMainViewResponse::setItemID()
     * @param int $getMainViewResult
     * @param string $itemID
     */
    public function __construct($getMainViewResult = null, $itemID = null)
    {
        $this
            ->setGetMainViewResult($getMainViewResult)
            ->setItemID($itemID);
    }
    /**
     * Get GetMainViewResult value
     * @return int
     */
    public function getGetMainViewResult()
    {
        return $this->GetMainViewResult;
    }
    /**
     * Set GetMainViewResult value
     * @param int $getMainViewResult
     * @return \Farfetch\StructType\GetMainViewResponse
     */
    public function setGetMainViewResult($getMainViewResult = null)
    {
        // validation for constraint: int
        if (!is_null($getMainViewResult) && !(is_int($getMainViewResult) || ctype_digit($getMainViewResult))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($getMainViewResult, true), gettype($getMainViewResult)), __LINE__);
        }
        $this->GetMainViewResult = $getMainViewResult;
        return $this;
    }
    /**
     * Get ItemID value
     * @return string|null
     */
    public function getItemID()
    {
        return $this->ItemID;
    }
    /**
     * Set ItemID value
     * @param string $itemID
     * @return \Farfetch\StructType\GetMainViewResponse
     */
    public function setItemID($itemID = null)
    {
        // validation for constraint: string
        if (!is_null($itemID) && !is_string($itemID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemID, true), gettype($itemID)), __LINE__);
        }
        $this->ItemID = $itemID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Farfetch\StructType\GetMainViewResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
