<?php

namespace Farfetch\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSKUandDesingerID StructType
 * @subpackage Structs
 */
class GetSKUandDesingerID extends AbstractStructBase
{
    /**
     * The storeid
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $storeid;
    /**
     * The FFitemId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $FFitemId;
    /**
     * The SafeKey
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SafeKey;
    /**
     * The SKU
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SKU;
    /**
     * Constructor method for GetSKUandDesingerID
     * @uses GetSKUandDesingerID::setStoreid()
     * @uses GetSKUandDesingerID::setFFitemId()
     * @uses GetSKUandDesingerID::setSafeKey()
     * @uses GetSKUandDesingerID::setSKU()
     * @param int $storeid
     * @param int $fFitemId
     * @param string $safeKey
     * @param string $sKU
     */
    public function __construct($storeid = null, $fFitemId = null, $safeKey = null, $sKU = null)
    {
        $this
            ->setStoreid($storeid)
            ->setFFitemId($fFitemId)
            ->setSafeKey($safeKey)
            ->setSKU($sKU);
    }
    /**
     * Get storeid value
     * @return int
     */
    public function getStoreid()
    {
        return $this->storeid;
    }
    /**
     * Set storeid value
     * @param int $storeid
     * @return \Farfetch\StructType\GetSKUandDesingerID
     */
    public function setStoreid($storeid = null)
    {
        // validation for constraint: int
        if (!is_null($storeid) && !(is_int($storeid) || ctype_digit($storeid))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($storeid, true), gettype($storeid)), __LINE__);
        }
        $this->storeid = $storeid;
        return $this;
    }
    /**
     * Get FFitemId value
     * @return int
     */
    public function getFFitemId()
    {
        return $this->FFitemId;
    }
    /**
     * Set FFitemId value
     * @param int $fFitemId
     * @return \Farfetch\StructType\GetSKUandDesingerID
     */
    public function setFFitemId($fFitemId = null)
    {
        // validation for constraint: int
        if (!is_null($fFitemId) && !(is_int($fFitemId) || ctype_digit($fFitemId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fFitemId, true), gettype($fFitemId)), __LINE__);
        }
        $this->FFitemId = $fFitemId;
        return $this;
    }
    /**
     * Get SafeKey value
     * @return string|null
     */
    public function getSafeKey()
    {
        return $this->SafeKey;
    }
    /**
     * Set SafeKey value
     * @param string $safeKey
     * @return \Farfetch\StructType\GetSKUandDesingerID
     */
    public function setSafeKey($safeKey = null)
    {
        // validation for constraint: string
        if (!is_null($safeKey) && !is_string($safeKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($safeKey, true), gettype($safeKey)), __LINE__);
        }
        $this->SafeKey = $safeKey;
        return $this;
    }
    /**
     * Get SKU value
     * @return string|null
     */
    public function getSKU()
    {
        return $this->SKU;
    }
    /**
     * Set SKU value
     * @param string $sKU
     * @return \Farfetch\StructType\GetSKUandDesingerID
     */
    public function setSKU($sKU = null)
    {
        // validation for constraint: string
        if (!is_null($sKU) && !is_string($sKU)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sKU, true), gettype($sKU)), __LINE__);
        }
        $this->SKU = $sKU;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Farfetch\StructType\GetSKUandDesingerID
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
