<?php

namespace Farfetch\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSKUandDesingerIDResponse StructType
 * @subpackage Structs
 */
class GetSKUandDesingerIDResponse extends AbstractStructBase
{
    /**
     * The GetSKUandDesingerIDResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $GetSKUandDesingerIDResult;
    /**
     * The SKU
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SKU;
    /**
     * Constructor method for GetSKUandDesingerIDResponse
     * @uses GetSKUandDesingerIDResponse::setGetSKUandDesingerIDResult()
     * @uses GetSKUandDesingerIDResponse::setSKU()
     * @param string $getSKUandDesingerIDResult
     * @param string $sKU
     */
    public function __construct($getSKUandDesingerIDResult = null, $sKU = null)
    {
        $this
            ->setGetSKUandDesingerIDResult($getSKUandDesingerIDResult)
            ->setSKU($sKU);
    }
    /**
     * Get GetSKUandDesingerIDResult value
     * @return string|null
     */
    public function getGetSKUandDesingerIDResult()
    {
        return $this->GetSKUandDesingerIDResult;
    }
    /**
     * Set GetSKUandDesingerIDResult value
     * @param string $getSKUandDesingerIDResult
     * @return \Farfetch\StructType\GetSKUandDesingerIDResponse
     */
    public function setGetSKUandDesingerIDResult($getSKUandDesingerIDResult = null)
    {
        // validation for constraint: string
        if (!is_null($getSKUandDesingerIDResult) && !is_string($getSKUandDesingerIDResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($getSKUandDesingerIDResult, true), gettype($getSKUandDesingerIDResult)), __LINE__);
        }
        $this->GetSKUandDesingerIDResult = $getSKUandDesingerIDResult;
        return $this;
    }
    /**
     * Get SKU value
     * @return string|null
     */
    public function getSKU()
    {
        return $this->SKU;
    }
    /**
     * Set SKU value
     * @param string $sKU
     * @return \Farfetch\StructType\GetSKUandDesingerIDResponse
     */
    public function setSKU($sKU = null)
    {
        // validation for constraint: string
        if (!is_null($sKU) && !is_string($sKU)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sKU, true), gettype($sKU)), __LINE__);
        }
        $this->SKU = $sKU;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Farfetch\StructType\GetSKUandDesingerIDResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
