<?php

namespace Farfetch\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MappDuplicatesResponse StructType
 * @subpackage Structs
 */
class MappDuplicatesResponse extends AbstractStructBase
{
    /**
     * The MappDuplicatesResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $MappDuplicatesResult;
    /**
     * The errorMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $errorMessage;
    /**
     * Constructor method for MappDuplicatesResponse
     * @uses MappDuplicatesResponse::setMappDuplicatesResult()
     * @uses MappDuplicatesResponse::setErrorMessage()
     * @param bool $mappDuplicatesResult
     * @param string $errorMessage
     */
    public function __construct($mappDuplicatesResult = null, $errorMessage = null)
    {
        $this
            ->setMappDuplicatesResult($mappDuplicatesResult)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get MappDuplicatesResult value
     * @return bool
     */
    public function getMappDuplicatesResult()
    {
        return $this->MappDuplicatesResult;
    }
    /**
     * Set MappDuplicatesResult value
     * @param bool $mappDuplicatesResult
     * @return \Farfetch\StructType\MappDuplicatesResponse
     */
    public function setMappDuplicatesResult($mappDuplicatesResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($mappDuplicatesResult) && !is_bool($mappDuplicatesResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($mappDuplicatesResult, true), gettype($mappDuplicatesResult)), __LINE__);
        }
        $this->MappDuplicatesResult = $mappDuplicatesResult;
        return $this;
    }
    /**
     * Get errorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->errorMessage;
    }
    /**
     * Set errorMessage value
     * @param string $errorMessage
     * @return \Farfetch\StructType\MappDuplicatesResponse
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->errorMessage = $errorMessage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Farfetch\StructType\MappDuplicatesResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
